<template>
    <single-pane capt='Доменные настройки'>
        <domain-settings-grid
                :settings="domainSettings"
                @change-setting="changeSetting"
                @save="onSave"
                @revert="onRevert"
        ></domain-settings-grid>
    </single-pane>
</template>

<script>
    import api from "../../api"
    import SinglePane from "common-components/src/obComponents/obSinglePanels";
    import { PARTICIPANT_ROLES, VIEW_DIRECTION, VISIBILITY_PERMISSION, LINK_PERMISSION, SCOPE } from '../../resources/log_domains_const'
    import { GET_CHANGED_DOMAIN_SETTINGS, GET_CHANGED_LINK_SETTING, GET_PREPARED_SETTINGS } from '../../helpers/logistic-domains/moderator/domain-settings'
    import cloneDeep from 'clone-deep'
    import DomainSettingsGrid from "./domain-settings/DomainSettingsGrid";
    export default {
        name: "index",
        components: {DomainSettingsGrid, SinglePane},
        computed: {
            api () {
                return api
            },
            linkAccessList () {
                return [
                    { access: LINK_PERMISSION.ALLOWED, name: 'Может создать линк', description: 'Некоторое описание параметров видимости' },
                    { access: LINK_PERMISSION.BY_REQUEST, name: 'Требует согласования', description: 'Некоторое описание параметров видимости' },
                    { access: LINK_PERMISSION.DISALLOWED, name: 'Не может создать линк', description: 'Некоторое описание параметров видимости' }
                ]
            },
            accessList () {
                return [
                    { access: VISIBILITY_PERMISSION.VISIBILITY, name: 'Видит', description: 'Некоторое описание параметров видимости' },
                    { access: VISIBILITY_PERMISSION.NOT_VISIBILITY, name: 'Не видит', description: 'Некоторое описание параметров видимости' }
                ]
            },
            orgInDomainSettings () {
                return [
                    {
                        id: 1,
                        name: 'Мои Клиенты',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CLIENT,
                        viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Меня', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: false, type: 'Моих Поставщиков', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Экспедиторов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужих Поставщиков', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 2,
                        name: 'Мои Поставщики',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CARRIER,
                        viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Меня', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: false, type: 'Моих Клиентов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Экспедиторов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужих Клиентов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 3,
                        name: 'Экспедиторы',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.EXPEDITOR,
                        viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Меня', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: true, type: 'Своих Клиентов и Поставщиков', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Других Экспедиторов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужих Клиентов и Поставщиков', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 4,
                        name: 'Клиенты Экспедиторов',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CLIENT,
                        viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Своего Экспедитора', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: true, type: 'Поставщиков своего Экспедитора', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Меня и других Экспедиторов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужих Поставщиков', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 5,
                        name: 'Поставщики Экспедиторов',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CARRIER,
                        viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Своего Экспедитора', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: true, type: 'Клиентов своего Экспедитора', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Меня и других Экспедиторов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужих Клиентов', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    }
                ]
            },
            orgInDomainFromOtherOrgSettings () {
                return [
                    {
                        id: 1,
                        name: 'Моих Клиентов',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CLIENT,
                        viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Я', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: false, type: 'Мои Поставщики', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Экспедиторы', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужие Поставщики', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 2,
                        name: 'Моих Поставщиков',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CARRIER,
                        viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Я', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: false, type: 'Мои Клиенты', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Экспедиторы', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужие Клиенты', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 3,
                        name: 'Экспедиторов',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.EXPEDITOR,
                        viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Я', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: true, type: 'Свои Клиенты и Поставщики', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Другие Экспедиторы', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужие Клиенты и Поставщики', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 4,
                        name: 'Клиентов Экспедиторов',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CLIENT,
                        viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Свой Экспедитор', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: true, type: 'Поставщики своего Экспедитора', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Я и другие Экспедиторы', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужие Поставщики', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 5,
                        name: 'Поставщиков Экспедиторов',
                        description: 'видят',
                        role: PARTICIPANT_ROLES.CARRIER,
                        viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Свой Экспедитор', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: true, type: 'Клиенты своего Экспедитора', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, type: 'Я и другие Экспедиторы', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, type: 'Чужие Клиенты', availableAccessList: this.accessList, access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    }
                ]
            },
            accessCreateLinkForOrgInDomainSettings () {
                return [
                    {
                        id: 1,
                        name: 'Мои Клиенты',
                        description: 'могут создавать',
                        role: PARTICIPANT_ROLES.CLIENT,
                        viewDirection: VIEW_DIRECTION.LINKS,
                        accessList: [
                            { keyAccess: 0, disabled: false, type: 'Внутренние линки с моими Поставщиками', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 1, disabled: false, type: 'Внешние линки с Экспедиторами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 2, disabled: false, type: 'Внешние линки с чужими Поставщиками', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 3, disabled: false, type: 'Публичные линки', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED }
                        ]
                    },
                    {
                        id: 2,
                        name: 'Мои Поставщики',
                        description: 'могут создавать',
                        role: PARTICIPANT_ROLES.CARRIER,
                        viewDirection: VIEW_DIRECTION.LINKS,
                        accessList: [
                            { keyAccess: 0, disabled: false, type: 'Внутренние линки с моими Клиентами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 1, disabled: false, type: 'Внешние линки с Экспедиторами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 2, disabled: false, type: 'Внешние линки с чужими Клиентами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 3, disabled: false, type: 'Публичные линки', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED }
                        ]
                    },
                    {
                        id: 3,
                        name: 'Экспедиторы',
                        description: 'могут создавать',
                        role: PARTICIPANT_ROLES.EXPEDITOR,
                        viewDirection: VIEW_DIRECTION.LINKS,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Внутренние линки со своими Клиентами и Поставщиками', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 1, disabled: false, type: 'Внешние линки с другими Экспедиторами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 2, disabled: false, type: 'Внешние линки с чужими Клиентами и Поставщиками', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 3, disabled: false, type: 'Публичные линки', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED }
                        ]
                    },
                    {
                        id: 4,
                        name: 'Клиенты Экспедиторов',
                        description: 'могут создавать',
                        role: PARTICIPANT_ROLES.CLIENT,
                        viewDirection: VIEW_DIRECTION.LINKS,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Внутренние линки с Поставщиками своего Экспедитора', availableAccessList: this.linkAccessList, access: 'create-link' },
                            { keyAccess: 1, disabled: false, type: 'Внешние линки со Мной и другими Экспедиторами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 2, disabled: false, type: 'Внешние линки с чужими Поставщиками', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 3, disabled: false, type: 'Публичные линки', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED }
                        ]
                    },
                    {
                        id: 5,
                        name: 'Поставщики Экспедиторов',
                        description: 'могут создавать',
                        role: PARTICIPANT_ROLES.CARRIER,
                        viewDirection: VIEW_DIRECTION.LINKS,
                        accessList: [
                            { keyAccess: 0, disabled: true, type: 'Внутренние линки с Клиентами своего Экспедитора', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 1, disabled: false, type: 'Внешние линки со Мной и другими Экспедиторами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 2, disabled: false, type: 'Внешние линки с чужими Клиентами', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 3, disabled: false, type: 'Публичные линки', availableAccessList: this.linkAccessList, access: LINK_PERMISSION.ALLOWED }
                        ]
                    }
                ]
            }
        },
        data () {
            return {
                initialDomainSettings: [],
                domainSettings: [],
                timeSetting: 0,
                changedSystemParticipantSettings: {},
                changedDomainParticipantSettings: {},
                changedTimeSetting: 0
            }
        },
        mounted() {
            this.getDomainSettings()
        },
        methods: {
            async getDomainSettings () {
                try {
                    let response = await Promise.all([this.api.domainSettingsModerator.getDomainSettings(), this.api.domainSettingsModerator.getTimeSettings()]);
                    this.initialDomainSettings = response[0].data ? response[0].data.settings : []
                    this.timeSetting = response[1].data ? response[1].data.requestLifetime : 0
                    this.domainSettings = this.getConvertedDomainSettings(this.initialDomainSettings, this.timeSetting)
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }            },
            getConvertedDomainSettings (settings, timeSetting) {
                let _LGDSShowOrgInDomain = cloneDeep(this.orgInDomainSettings);
                let _LGDSShowOrgInDomainFromOtherOrgs = cloneDeep(this.orgInDomainFromOtherOrgSettings);
                let _LGDSAccessCreateLinkForOrgInDomain = cloneDeep(this.accessCreateLinkForOrgInDomainSettings);

                let getIndexTargetParticipantRole = (setting) => {
                    switch (setting.targetParticipantRole) {
                        case PARTICIPANT_ROLES.MODERATOR:
                        case PARTICIPANT_ROLES.EXPEDITOR:
                            return !setting.isCrossDomainScope ? 0 : 2;
                        case PARTICIPANT_ROLES.CLIENT:
                        case PARTICIPANT_ROLES.CARRIER:
                            return !setting.isCrossDomainScope ? 1 : 3;
                    }
                };
                let changeSetting = (setting, indexParticipantRole, indexLinkPermission) => {
                    let indexTargetParticipantRole = getIndexTargetParticipantRole(setting);
                    switch (setting.viewDirection) {
                        case VIEW_DIRECTION.BY_PARTICIPANT:
                            _LGDSShowOrgInDomain[indexParticipantRole].accessList[indexTargetParticipantRole].access = setting.visibilityPermission;
                            _LGDSAccessCreateLinkForOrgInDomain[indexParticipantRole].accessList[3].access = setting.publicateLinkPermission;
                            if(indexLinkPermission !== undefined) {
                                _LGDSAccessCreateLinkForOrgInDomain[indexParticipantRole].accessList[indexLinkPermission].access = setting.createLinkPermission;
                            }
                            break;
                        case VIEW_DIRECTION.AT_PARTICIPANT:
                            _LGDSShowOrgInDomainFromOtherOrgs[indexParticipantRole].accessList[indexTargetParticipantRole].access = setting.visibilityPermission;
                            break;
                    }
                };

                settings.forEach(setting => {
                    let indexParticipantRole;
                    let indexLinkPermission;
                    switch (setting.participantRole) {
                        case PARTICIPANT_ROLES.EXPEDITOR:
                            indexParticipantRole = 2;
                            break;
                        case PARTICIPANT_ROLES.CLIENT:
                            indexParticipantRole = setting.scope === SCOPE.SYSTEM ? 3 : 0;
                            break;
                        case PARTICIPANT_ROLES.CARRIER:
                            indexParticipantRole = setting.scope === SCOPE.SYSTEM ? 4 : 1;
                            break;
                    }
                    switch (setting.targetParticipantRole) {
                        case PARTICIPANT_ROLES.MODERATOR:
                        case PARTICIPANT_ROLES.EXPEDITOR:
                            if(setting.isCrossDomainScope) {
                                indexLinkPermission = 1;
                            }
                            break;
                        case PARTICIPANT_ROLES.CLIENT:
                        case PARTICIPANT_ROLES.CARRIER:
                            indexLinkPermission = !setting.isCrossDomainScope ? 0 : 2;
                            break;
                    }
                    changeSetting(setting, indexParticipantRole, indexLinkPermission);
                });
                return [
                    { id: 1, title: 'Параметры видимости участников со стороны моего домена', viewDirection: VIEW_DIRECTION.BY_PARTICIPANT, type: 'access-grid', editItemCount: 0, value: _LGDSShowOrgInDomain },
                    { id: 2, title: 'Параметры видимости участников моего домена со стороны других участников', viewDirection: VIEW_DIRECTION.AT_PARTICIPANT, type: 'access-grid', editItemCount: 0, value: _LGDSShowOrgInDomainFromOtherOrgs },
                    { id: 3, title: 'Возможность создания линков для участников в доменах', viewDirection: VIEW_DIRECTION.LINKS, type: 'access-grid', editItemCount: 0, value: _LGDSAccessCreateLinkForOrgInDomain },
                    { id: 4, title: 'Лимит времени на принятия решения о создании ли публикации линка ', viewDirection: VIEW_DIRECTION.LIMIT, type: 'limit', editItemCount: 0, value: timeSetting }
                ];
            },
            changeSetting (row, access, status) {
                if(row.viewDirection === VIEW_DIRECTION.LIMIT) {
                    this.changedTimeSetting = access
                }
                else {
                    let keyChangedSettings = row.id > 2 ? 'changedSystemParticipantSettings' : 'changedDomainParticipantSettings';
                    if(!this[keyChangedSettings][row.viewDirection]) {
                        this[keyChangedSettings][row.viewDirection] = [];
                    }
                    //Изменение видимости
                    if( row.viewDirection === VIEW_DIRECTION.AT_PARTICIPANT ||
                        row.viewDirection === VIEW_DIRECTION.BY_PARTICIPANT) {
                        this[keyChangedSettings][row.viewDirection] = GET_CHANGED_DOMAIN_SETTINGS(
                            this[keyChangedSettings][row.viewDirection],
                            this.initialDomainSettings,
                            row,
                            access,
                            status
                        );
                    }
                    //Изменение возможности создания линков
                    else if(row.viewDirection === VIEW_DIRECTION.LINKS) {
                        this[keyChangedSettings][row.viewDirection] = GET_CHANGED_LINK_SETTING(this[keyChangedSettings][row.viewDirection], row, access, status);
                    }
                }

            },
            onSave(row) {
                let notificationId = new Date().getTime() + 'save';
                this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
                let preparedSettings;
                if (row.viewDirection !== VIEW_DIRECTION.LIMIT) {
                    let _settings = !this.changedDomainParticipantSettings[row.viewDirection] ? [] : this.changedDomainParticipantSettings[row.viewDirection];
                    let _systemSettings = !this.changedSystemParticipantSettings[row.viewDirection] ? [] : this.changedSystemParticipantSettings[row.viewDirection];
                    preparedSettings = GET_PREPARED_SETTINGS(
                        row.viewDirection,
                        this.initialDomainSettings,
                        _settings,
                        _systemSettings
                    );
                    this.api.domainSettingsModerator.putDomainSettings({settings: preparedSettings}).then(({data}) => {
                        this.initialDomainSettings = cloneDeep(data.settings);
                        let indexSettings;
                        switch (row.viewDirection) {
                            case VIEW_DIRECTION.BY_PARTICIPANT:
                                indexSettings = 0;
                                break;
                            case VIEW_DIRECTION.AT_PARTICIPANT:
                                indexSettings = 1;
                                break;
                            case VIEW_DIRECTION.LINKS:
                                indexSettings = 2;
                                break;
                        }
                        this.$set(this.domainSettings, indexSettings, this.getConvertedDomainSettings(data.settings, this.timeSetting)[indexSettings])
                        this.changedDomainParticipantSettings[row.viewDirection] = [];
                        this.changedSystemParticipantSettings[row.viewDirection] = [];
                        this.$notification({
                            type: 'system_notification_success',
                            message: 'Сохранено'
                        })
                    }).catch((e) => {
                        console.error(e);
                        this.$notification({
                            type: 'system_notification_error',
                            message: 'Не сохранено'
                        })
                    }).finally(() => {
                        this.$notification({event: 'close', id: notificationId})
                    });
                } else {
                    this.api.domainSettingsModerator.putTimeSettings({
                        requestLifetime: this.changedTimeSetting
                    }).then(({data} = {}) => {
                        this.timeSetting = data.requestLifetime
                        this.$set(this.domainSettings, 3, this.getConvertedDomainSettings(this.initialDomainSettings, data.requestLifetime)[3])
                        this.$notification({
                            type: 'system_notification_success',
                            message: 'Сохранено'
                        })
                    }).catch((e) => {
                        console.error(e);
                        this.$notification({
                            type: 'system_notification_error',
                            message: 'Не сохранено'
                        })
                    }).finally(() => {
                        this.$notification({event: 'close', id: notificationId})
                    });
                }

            },
            onRevert (row) {
                if(row.viewDirection !== VIEW_DIRECTION.LIMIT) {
                    this.changedDomainParticipantSettings[row.viewDirection] = [];
                    this.changedSystemParticipantSettings[row.viewDirection] = [];
                }
            },
        }
    }
</script>

<style scoped>

</style>
